/* clavier.h
  La definition des touches clavier pour le programme d'apprentissage de la
  dactylographie XFRAP.

  jm, avril 1991
  jm, 21 mai 1991 : fait de la place pour le bit placer
  jm, 22 mai 1991 : defini les constantes clavier
  jm, 27 mai 1991 : ajoute QWERTY_CABLE et DVORAK_CABLE
  jm, 14 juin 1991 : ajoute NCD
 */
# define NMOD 2

struct touche {
  int flag;
  char *voir[NMOD];		/* sur la touche, avec et sans shift */
# define up	voir[0]
# define down	voir[1]
  int width, height;		/* normalement rsize X rsize */
  int x, y;			/* position du rectangle dans le clavier */
};

/*
  les flags doivent commencer a 32,
  les valeurs inferieures sont utilisees dans les cabochons
 */
# define SOULIGNER	32	/* epaissir le rectangle */
# define GRISE		64	/* griser le fond de la touche */

extern struct touche * touche;	/* toutes les touches */
extern struct touche * ascii2touche[];
extern struct touche trop;	/* dimensions maximales */

extern int rsize;		/* taille interne d'une touche ordinaire */

/*
  Les differentes sortes de keycodes et tailles de touches.
  les valeurs indicent le tableau cab[] de clavier.c
  */
# define QWERTY_CABLE 0
# define DVORAK_CABLE 1
# define SUN	2
# define SONY	3
# define APOLLO	4
# define NCD	5
