/* commencer.c
 Faire une fenetre pour commencer une session X en s'efforcant de respecter
 le protocole,
 Positionne les variables d, w, fd, noir, blanc, bordc
 jm, 14 septembre 90 : je vire le XSelectInput, je pense qu'il est mieux dans main.
 jm, avril 1991 : serieusement modifie pour utiliser dans xtype
 jm, 25 avril 1991 : j'ai compris mon probleme avec XGetDefault, c'est la
	doc qui est erronee quant a l'ordre des arguments
 jm, 14 mai 1991 : le traitement des options, sauf -display, dans options.c
 jm, 21 mai 1991 : retire de XCopyArea de trop dans la fabrication de la texture
 jm, 27 mai 1991 : ajoute le positionnement du flag monochrome
 */
# include <X11/Xlib.h>
# include <X11/Xutil.h>

# include <stdio.h>
char * getenv();

# define BACKUP_POLICE	"fixed"
# ifndef ENGLISH
#   define BACKUP_NAME	"Pas de nom"
# else
#   define BACKUP_NAME	"No Name"
# endif

	/* positionnes dans options.c a partir de argv et des ressources */
extern char * serveur;
extern char * police_clavier;
extern char * police_texte;
extern char * arggeometrie;
extern char * resgeometrie;
extern char * nom_couleur_fond;
extern char * nom_couleur_devant;
extern char * nom_couleur_bord;
extern char * nom_couleur_gris;
extern long bord;
extern char * nom_programme;
extern char * nom_ressource;
extern char * nom_classe;
extern char * nom_icone;

	/* A poser avant d'appeler commencer (valeur par defaut) */
XRectangle r = {10, 10, 80, 24};; /* geometrie de la fenetre */
char * nom_display = NULL;
int _debug_;

	/* a utiliser apres avoir appele' commencer */
Display *	d;		/* display (== station) */
Window		w;		/* fenetre */
long		noir, blanc;	/* les couleurs pour devant et derriere */
long		bordc;		/* la couleur du bord */
XFontStruct *	tfd;		/* police du clavier */
XFontStruct *	cfd;		/* police du texte */

int monochrome;			/* decide lors de l'allocation de couleurs */

	/* dans options.c */
extern char * police_clavier, * police_texte;

commencer(ac, av)
     char * av[];
{
  XSizeHints sw;

  /*
   * Ouvrir le display
   */
  { int i;

    for(nom_display = getenv("DISPLAY"), i = 1; i < ac; i += 1)
      if (filtre(av[i], "-display")){
	if (i + 1 < ac)
	  nom_display = av[i + 1];
	else
	  usage();
	break;
      }
    if ((d = XOpenDisplay(nom_display)) == NULL){
# ifndef ENGLISH
      fprintf(stderr, "Je ne peux pas ouvrir le display %s\n", nom_display);
# else
      fprintf(stderr, "Unable to open the display %s\n", nom_display);
# endif
      exit(0);
    }
  }

  /*
   *  fusionner les options de la ligne de commande et les ressources
   */
  options(ac, av);

  /*
   * Charger les polices
   */
  { static XFontStruct * nofont();

    if ((cfd = XLoadQueryFont(d, police_clavier)) == NULL)
      cfd = nofont(police_clavier);

    if ((tfd = XLoadQueryFont(d, police_texte)) == NULL)
      tfd = nofont(police_texte);
  }
  /*
   * Former la geometrie : taille et position (positive)
   */
  { int f = 0, ff = 0;
    int x, y;
    unsigned int wi, h;
				/* par ressource */
    if (resgeometrie != NULL)
      ff = XParseGeometry(resgeometrie, &x, &y, &wi, &h);
				/* par argument */
    if (arggeometrie != NULL)
      f = XParseGeometry(arggeometrie, &x, &y, &wi, &h);
				/* fusionner */
    sw.width = ((f | ff) & WidthValue) ? r.width = wi : r.width;
    sw.height = ((f | ff) & HeightValue) ? r.height = h : r.height;
# define doX(f)	((f&XNegative)?DisplayWidth(d,DefaultScreen(d))+x-sw.width:x)
# define doY(f) ((f&YNegative)?DisplayHeight(d,DefaultScreen(d))+y-sw.height:y)
    sw.x = (f & XValue) ? r.x = doX(f) : (ff & XValue) ? r.x = doX(ff) : r.x;
    sw.y = (f & YValue) ? r.y = doY(ff) : (ff & YValue) ? r.y = doY(ff) : r.y;
# undef doX
# undef doY

    r.width = sw.width *= XTextWidth(tfd, "m", 1);
    r.height = sw.height *= tfd->ascent + tfd->descent;

    sw.flags = (((f & (XValue|YValue)) ? USPosition : PPosition)
		| (((f | ff) & (WidthValue|HeightValue)) ? USSize : PSize));

  }
  /*
   * Trouver les bonnes couleurs ou n/b
   */
  { static unsigned long faireCouleur();
# define white()	WhitePixel(d, DefaultScreen(d))
# define black()	BlackPixel(d, DefaultScreen(d))
    blanc = faireCouleur(nom_couleur_fond, white());
    noir = faireCouleur(nom_couleur_devant, black());
    bordc = faireCouleur(nom_couleur_bord, black());
  }

  /*
   * Creer la fenetre
   */
  w = XCreateSimpleWindow(d, RootWindow(d, DefaultScreen(d)),
			  r.x, r.y, r.width, r.height, /* geometrie */
			  bord, bordc,	  /* bord */
			  blanc);	  /* fond */
  /*
   * Poser les propriete's indispensables d'apres les ICCCM
   */
  { XClassHint xch;
# ifndef R3
# ifndef R35
    XTextProperty pname, iname;
# endif
# endif

    XWMHints xwmh;
    char * bidon[1];

    xwmh.input = True;
    xwmh.initial_state = NormalState;
    xwmh.flags = (InputHint|StateHint);
    
# ifndef R3
# ifndef R35
    bidon[0] = (nom_programme != NULL ? nom_programme : BACKUP_NAME);
    XStringListToTextProperty(bidon, 1, &pname);

    bidon[0] = (nom_icone != NULL ? nom_icone : BACKUP_NAME);
    XStringListToTextProperty(bidon, 1, &iname);
# endif
# endif

    xch.res_name = nom_ressource;
    xch.res_class = nom_classe;

# ifndef R3
    XSetWMProperties(d, w,
#   ifndef R35
		     &pname, &iname,
#   else /* R35 */
		     NULL, NULL,
#   endif /* R35 */
		     av, ac, &sw, &xwmh, &xch);
# else /* R3 */
    XSetStandardProperties(d, w,
			   (nom_programme != NULL ? nom_programme : BACKUP_NAME),
			   (nom_icone != NULL ? nom_icone : BACKUP_NAME),
			   av, ac,
			   %sw);
# endif /* R3 */
  }
}

/* nofont  --  on n'arrive pas a charger de police */
static XFontStruct *
nofont(s)
     char * s;
{
  XFontStruct * p;
  
  if ((p = XLoadQueryFont(d, BACKUP_POLICE)) == NULL){
    fprintf(stderr,
# ifndef ENGLISH
	    "Ni police %s, ni %s, tant pis",
# else
	    "No font %s, nor %s, (quitting)",
# endif
	    s, BACKUP_POLICE);
      exit(1);
    }
  fprintf(stderr,
# ifndef ENGLISH
	  "Pas de police %s, j'utilise %s pour le texte\n",
# else
	  "No font %s, using %s for the text\n",
# endif
	  s, BACKUP_POLICE);
  return p;
}

/* faireCouleur  --- couleur : ressource, ou programme, ou defaut sinon */
unsigned long
faireCouleur(prg, valdef)
     char * prg;
     unsigned long valdef;
{
  XColor xc;

  return 
    (prg == NULL
     || XParseColor(d, DefaultColormap(d, DefaultScreen(d)), prg, &xc) == 0
     || XAllocColor(d, DefaultColormap(d, DefaultScreen(d)), &xc) == 0)
      ? valdef : xc.pixel;
}


GC gcafaire,			/* texte a faire : noir */
  gcdefait,			/* oter le texte a faire */
  gcfait,			/* texte fait : gris ou texture */
  gcclav,			/* pour le clavier : noir, ligne de 1 */
  gcclavgras,			/*  idem avec ligne + epaisse */
  gcrev,			/* inverser noir et blanc */
  gcgris2noir,			/* faire passer le gris en noir */
  gcazero;			/* nettoyer une zone */

/* initGC  --  fabriquer les gc */
initGC()
{
  XGCValues gcv;
  long gris;
  extern int tcadre;		/* dans xtype.c */
 
# define ECHEC -1
  if ((gris = faireCouleur(nom_couleur_gris, NULL, ECHEC)) == ECHEC
# undef ECHEC
      || gris == noir
      || gris == blanc){
    unsigned int sw, sh, i;
    Pixmap p;
    GC gc1, gc0;

    monochrome = 1;
# define TILE_LARGE 128		/* ce n'est qu'une proposition */
# define TILE_HAUT  128
    XQueryBestStipple(d, w, TILE_LARGE, TILE_HAUT, &sw, &sh);
# undef TILE_LARGE
# undef TILE_HAUT
    if (sw < 2 || sh < 2){
# ifndef ENGLISH
      fprintf(stderr, "Les tiles de taille %dx%d sont trop petits, tant pis\n",
# else
      fprintf(stderr, "The size of tiles %dx%d is too small, (quitting)\n",
# endif
	      sw, sh);
      exit(1);
    } else if ((sw&1) || (sh&1)){
      fprintf(stderr,
# ifndef ENGLISH
	      "La taille %dx%d des tiles n'est pas multiple de deux, tant pis\n",
# else
	      "The size of tiles %dx%d is not a multiple of two (quitting)\n",
# endif
	      sw, sh);
      exit(1);
    }      
    p = XCreatePixmap(d, w, sw, sh, 1);
    gc1 = XCreateGC(d, p, 0, &gcv);
    XSetGraphicsExposures(d, gc1, False);
    XSetForeground(d, gc1, 1);
    gc0 = XCreateGC(d, p, 0, &gcv);
    XSetGraphicsExposures(d, gc0, False);
    XSetForeground(d, gc0, 0);

    XDrawPoint(d, p, gc1, 0, 0);
    XDrawPoint(d, p, gc1, 1, 1);
    XDrawPoint(d, p, gc0, 1, 0);
    XDrawPoint(d, p, gc0, 0, 1);

    for(i = 2; i < sw || i < sh; i += i ){
      XCopyArea(d, p, p, gc1, 0, 0, i, i, i, 0);
      XCopyArea(d, p, p, gc1, 0, 0, i + i, i, 0, i);
    }
    XFreeGC(d, gc1);
    XFreeGC(d, gc0);

    gcv.stipple = p;
    gcv.fill_style = FillStippled;
    gcv.foreground = noir;
    gcv.font = tfd->fid;
    gcv.function = GXcopy;
    gcfait = XCreateGC(d, w, (GCStipple|GCFillStyle
				|GCForeground|GCFunction|GCFont), &gcv);
    XFreePixmap(d, p);
  } else {
    monochrome = 0;
    gcv.foreground = gris;
    gcv.font = tfd->fid;
    gcv.function = GXcopy;
    gcfait = XCreateGC(d, w, GCForeground|GCFunction|GCFont, &gcv);
  }

  gcv.foreground = noir;
  gcv.function = GXcopy;
  gcv.font = tfd->fid;
  gcafaire = XCreateGC(d, w, GCForeground|GCFunction|GCFont, &gcv);

  gcv.foreground = noir^blanc;
  gcv.function = GXxor;
  gcv.font = tfd->fid;
  gcdefait = XCreateGC(d, w, GCForeground|GCFunction|GCFont, &gcv);

  gcv.foreground = noir;
  gcv.function = GXcopy;
  gcv.font = cfd->fid;
  gcv.line_width = (tcadre == 1 ? 0 : tcadre);
  gcclav = XCreateGC(d, w, GCForeground|GCFunction|GCFont|GCLineWidth, &gcv);
  gcv.line_width = 2 * tcadre;
  gcclavgras = XCreateGC(d, w, GCForeground|GCFunction|GCFont|GCLineWidth,
			 &gcv);

  gcv.function = GXinvert;
  gcv.plane_mask = blanc^noir;
  gcv.graphics_exposures = False;
  gcrev = XCreateGC(d, w, GCFunction|GCPlaneMask|GCGraphicsExposures, &gcv);

  gcv.plane_mask = gris^noir;
  gcgris2noir = XCreateGC(d, w, GCFunction|GCPlaneMask|GCGraphicsExposures, &gcv);

  gcv.foreground = blanc;
  gcv.function = GXcopy;
  gcv.graphics_exposures = False;
  gcazero = XCreateGC(d, w, GCForeground|GCFunction|GCGraphicsExposures, &gcv);
}  

