/*
 * 	frap.c
 *	pour apprendre a taper a la machine
 *	d'apres Typing Tutor sur TRS-80
 *			jm octobre 82
 */

#include <ctype.h>		/* Les types C */
#include <stdio.h>		/* Entrees sorties standard */
#include <signal.h>
#include <sys/types.h>
#include <sys/timeb.h>
/*
 * 	Les options
 */
#define O_FRAP 00001		/* rigueur face aux erreurs */
#define O_TEMPS 0002		/* rigueur face au temps */
#define O_FIC 000004		/* fichier pour garder ses trucs */
#define O_ERR 000010		/* erreur option */

#define L_ESSAI 8		/* Pour saisir un coup */
#define L_MODELE 10		/* Ligne modele */
#define C_MODELE 36		/* Colonne modele */
#define APPRISE 00001		/* Si on a deja apprise la touche */

#define FILUSERS	"/usr/grp/litp/pg/hacks/frap/users"
int onintr();
struct timeb heure;

struct touche {		/* Representation interne d'une touche */
	char car;		/* Caractere de la touche */
	char avec;		/* Caractere avec lequel l'introduire */
	int flags;		/* Info diverses */
	int n_app;		/* Nbre de fois ou on l'a apprise */
	int n_fois;		/* Nbre de fois ou on l'a tapee */
	int rates;		/* Nbre d'erreur de frappes sur la touche */
	int temps;		/* Tps de frappe en 1000/64eme de sec */
} alpha[] = {	/* Et les touches elles-meme */
/* 4 */	{'f','d',APPRISE },{'d','f',APPRISE },{'s','d'},{'a','s'},
/* 8 */	{'j','f'},{'k','j'},{'l','k'},{';','l'},
/* 12*/	{'r','f'},{'e','d'},{'w','s'},{'q','a'},
/* 16*/	{'u','j'},{'i','k'},{'o','l'},{'p',';'},
/* 20*/	{'g','f'},{'h','j'},{'t','f'},{'y','j'},
/* 24*/	{'v','f'},{'c','d'},{'x','s'},{'z','a'},
/* 28*/	{'m','j'},{',','k'},{'.','l'},{'/',';'},
/* 32*/ {'b','f'},{'n','j'},{'4','f'},{'3','d'},
/* 36*/	{'2','s'},{'1','a'},{'7','j'},{'8','k'},
/* 40*/	{'9','k'},{'0',';'},{'5','f'},{'6','j'},
	};
# define NSYM (sizeof alpha / sizeof alpha[0])

struct touche *vues[NSYM] =		/* Les touches deja connues */
	{&alpha[0],&alpha[1]};
#define CLAV_X 4
#define CLAV_Y 10
char *clav_sym = {
	"1234567890qwertyuiopasdfghjkl;zxcvbnm,./" };
struct touche *clav_tou[CLAV_X * CLAV_Y];

int n_vues = 2;				/* Nbre de touches vues */
struct touche *essai[L_ESSAI];		/* Sequence a essayer */

/*
 * 	La batterie pour l'evaluation
 */

int n_err = 0;		    		/* Nbre d'erreur de frappe */
int mm;					/* Milliemes de secondes */
time_t sec;				/* Secondes */
int n_tour = 3;				/* Nbre de tours ou on a joue */
int e_rigueur = 5;		/* La rigueur a manifester face au erreurs */
int t_rigueur = 40;			/* 	et face au temps de frappe */
int n_sansoter;				/* Nbre de tours sans oter qqchose */

char *erig, *trig, fic[132];
extern	char *optarg;
char getopt();
struct touche *quelcar();
int fd;
int opt;

main(argc,argv)char **argv;{
	char c;
	while((c = getopt(argc,argv,"evf")) != EOF){
		switch( c ){
		case 'e':
			opt |= O_FRAP;
			erig = optarg;
			break;
		case 'v':
			opt |= O_TEMPS;
			trig = optarg;
			break;
		case 'f':
			opt |= O_FIC;
			break;
		case '?':
			opt |= O_ERR;
			break;
		}
	}
	if (opt & O_ERR){
	    fputs("Usage: frap [-e erreurs][-v temps][-f fichier]\n", stderr);
	    exit(1);
	}
	if (opt & O_FIC){	/* ya un fichier de mentionne */
	    strcpy( fic, getenv("HOME"));
	    strcat(fic, "/.frap");
	    if ((fd = open(fic, 0)) > 1){
		read(fd, &e_rigueur, sizeof(e_rigueur ));
		read(fd, &t_rigueur, sizeof(t_rigueur ));
		for(n_vues = 0; read(fd, &c, 1) > 0; n_vues++){
			vues[n_vues] = quelcar(c);
			vues[n_vues]->flags |= APPRISE;
		}
		close(fd );
	    }
	}
	{
	    FILE *stream;
/* FOOBAR
	    stream=fopen(FILUSERS,"a");
	    fprintf(stream, "%s\n", getlogin());
	    fclose(stream);
*/
	}
	if (opt & O_FRAP)	e_rigueur = atoi(erig );
	if (opt & O_TEMPS)	t_rigueur = atoi(trig );

	inivid(argc,argv);
	cru();	home();	cleos();
	signal( SIGINT, onintr);
	srand( getpid());
	iniclav();
	affiche();
	for(;;){
	    remplit();
	    saisi();
	    modifie();
	}
}

iniclav()	/* Initialise le clav_tou a partir de clav_sym */
{
	register int i;
	struct touche **p_tou = clav_tou;
	char *p_sym = clav_sym;
	int borne = CLAV_X * CLAV_Y;
	for(i = 0; i < borne; i++, p_sym++)
		if ( *p_sym == '\0' )
			*(p_tou++) = (struct touche *)NULL;
		else
			*(p_tou++) = quelcar(*p_sym);
}

affiche()	/* Affiche les claviers du haut */
{
	int x, y, i;
	struct touche **p_tou = clav_tou;
register struct touche **p_aux;
	poscur(1,4); wst("Connues");
	poscur(1,38); wst("Clavier");
	poscur(1,72); wst("A voir");
	for(x = 0; x < CLAV_X; x++){	/* Quatre lignes */
	    poscur(2 + x, 1);			/* Se postionner */
	    p_aux = p_tou; p_aux--;
	    for(y = 0; y < CLAV_Y; y++)		/* Afficher si vues */
		write(1, ((*++p_aux != (struct touche *)NULL)
			  && ((*p_aux)->flags & APPRISE)
				? &(*p_aux)->car : " "), 1);
	    p_aux = p_tou; p_aux--;		/* Les memes */
	    poscur(2 + x, 35);			/* a la col 35 */
	    for(y = 0; y < CLAV_Y; y++)		/* Afficher */
		write(1, ((*++p_aux != (struct touche *)NULL)
				? &(*p_aux)->car : " "), 1);
	    p_aux = p_tou; p_aux--;		/* Les memes */
	    poscur(2 + x, 69);			/* a la col 69 */
	    for(y = 0; y < CLAV_Y; y++)    	/* Afficher si pas vues */
		write(1, ((*++p_aux != (struct touche *)NULL)
			  && (!((*p_aux)->flags & APPRISE))
				? &(*p_aux)->car : " "), 1);
	    p_tou = ++p_aux;
	}
}

remplit()	/* Remplit la grille modele */
{
	int i;
	for(i = 0; i < L_ESSAI; i++ )
	    essai[i] = vues[rand() % n_vues];
}

saisi()		/* Lit sur le clavier en comparant a la grille modele */
{
	char c;
	int i;
register struct touche **mod;
	poscur(L_MODELE, C_MODELE);
	for( i = 0, mod = essai; i < L_ESSAI; i++)
		write(1, &((*(mod++))->car), 1);
	poscur(L_MODELE+1, 1); cleol();
	poscur(L_MODELE+1, C_MODELE); 
	for(i = 0, mod = essai; i < L_ESSAI; ){
	    ftime( &heure );		/* Quelle heure est-il ? */
	    mm = heure.millitm;
	    sec = heure.time;
	    read(0, &c, 1);
	    if ( c == (*mod)->car ){	/* C'est la bonne touche ? */
		if ( i != 0 ){		/* Pas pour la premiere touche */
		    ftime( &heure );	/* Quelle heure est-il ? */
		    if (heure.time > sec)
			heure.millitm += 1000*(heure.time-sec);
					/* Combien de temps a-t-on mis */
		    (*mod)->n_fois++;
		    (*mod)->temps += (heure.millitm - mm)>>6;
		}
		write(1, &c, 1); mod++; i++;
		continue; }
	    (*mod)->rates++;
	    wst("");
	}
}



modifie()
{
	int i, f = 0;
	int n_ote = 0;
register struct touche **pp_touche;
	/* pp_touche va pointer sur un case du tableau 'vues' */
	/* Cette case pointe sur un case du tableau 'alpha' */
	/* Une case du tableau alpha contient un structure de lettre */
	if (!(n_tour % 4))	/* Tout les quatre tours on nettoie */
		f = 1;
	for(i = 0, pp_touche = vues; i < n_vues; i++, pp_touche++){
		if ((*pp_touche)->n_fois == 0)	continue;
		if ((*pp_touche)->temps / (*pp_touche)->n_fois > t_rigueur)
		{   ote(i);	n_ote++;	continue; }
		if ((*pp_touche)->rates > e_rigueur )
		{   ote(i);	n_ote++;	continue; }
		if (f){
		    (*pp_touche)->n_fois = 0;
		    (*pp_touche)->rates = 0;
		    (*pp_touche)->temps = 0;
		}
	}
	if ( n_ote != 0 ) n_sansoter = 0; else
	if ( ++n_sansoter == 2){ ajoute(); n_sansoter = 0;	}
}

ajoute()
{
	int j, x, y;
register struct touche *cecar;
	struct touche *av_car;
	char *ptr;
	cecar = alpha;
	while(cecar++->flags & APPRISE ); cecar--;
	vues[n_vues++] = cecar;
	cecar->flags |= APPRISE;
	cecar->n_app++;
	av_car = quelcar(cecar->avec );
	for(j = 0; j < L_ESSAI;){
	    essai[j++] = cecar;
	    essai[j++] = av_car;
	}
	do {
	    n_err = 0;
	    saisi();
	} while( n_err != 0);
	/* Effacer ds a voir */
	for( ptr = clav_sym; *ptr != cecar->car ; ptr++);
	j = ptr - clav_sym;	/* J = numero ds l'ordre du clavier */
	x = (j / CLAV_Y) + 2; y = (j % CLAV_Y) + 1;
	poscur(x, y + 68); wst(" ");
	poscur(x, y);	write(1, &cecar->car, 1);
}

ote(i)
int i;
{
register struct touche *cecar;
	char *ptr;
	int j, x, y;
	n_err = 0;
	if (n_vues < 3 )	return;
	cecar = vues[i];
	cecar->flags &= ~APPRISE;
	cecar->rates = 0;
	cecar->n_fois = 0;
	cecar->temps = 0;
	cecar->n_app++;
	vues[i] = vues[--n_vues];
	for( ptr = clav_sym; *ptr != cecar->car ; ptr++);
	j = ptr - clav_sym;	/* J = numero ds l'ordre du clavier */
	x = (j / CLAV_Y) + 2; y = (j % CLAV_Y) + 1;
	poscur(x, y); wst(" ");
	poscur(x, y + 68);	write(1, &cecar->car, 1);
}

#include <sgtty.h>
struct sgttyb ttyb;
int saveflags;
cru()
{
	gtty(2,&ttyb);
	saveflags = ttyb.sg_flags;
	ttyb.sg_flags &= ~ECHO;
	ttyb.sg_flags |= CBREAK;
	stty(2,&ttyb);
}
cuit()
{
	ttyb.sg_flags = saveflags;
	stty(2,&ttyb);
}
onintr()
{
	int i;
	home(); cleos();
	cuit();
	if (opt & O_FIC)
		if ((fd = creat( fic, 0666)) < 0)
			printf("Pas moyen d'ouvrir %s\n", fic);
		else {
			write(fd, &e_rigueur, sizeof(e_rigueur));
			write(fd, &t_rigueur, sizeof(t_rigueur));
			for(i = 0; i < n_vues; i++)
				write(fd, &vues[i]->car, 1);
		}
	wst("Bye.\n");
	exit(0);
}

struct touche
*quelcar( c )
 char c;
{
	int i;
	for(i = 0; i < NSYM; i++)
	    if ( c == alpha[i].car )
		return( &alpha[i] );
	return( (struct touche *)NULL);
}
