/*
 * frapp.c
 *	pour continuer a apprendre a taper a la machine
 *	d'apres Typing Tutor sur TRS-80
 *			jm octobre 82
 *			jm fevrier 83
 */

# include <ctype.h>		/* Les types C */
# include <stdio.h>		/* Entrees sorties standard */
# include <signal.h>
int onintr();
# include <sys/types.h>
# include <sys/timeb.h>
struct timeb heure, debut, fin;
# define NCOL 80
# define NLIG 23
# define BEEP '\007'
# define NSYM 127

struct carac {		/* Representation interne d'un caractere */
	char car;
	int n_fois;		/* Nbre de fois ou on l'a tape */
	long rates;		/* Nbre d'erreur de frappes sur le caractere */
	long temps;		/* Tps de frappe en 1000/64eme de sec */
} alpha[NSYM];			/* Et les caracteres eux-memes */

char a_taper[ NCOL * NLIG / 2 ];
char *fa_tap;
char *fil_mod = "/etc/passwd";
long nlus = 0L;
FILE * ssin;

main(argc,argv)
char **argv;
{
	int i;
	if ( argc == 2 )
		fil_mod = argv[1];
	signal( SIGINT, onintr);
	srand( getpid());
	if ( (ssin = fopen( fil_mod, "r" )) == NULL ){
		fprintf( stderr, "Pas moyen d'ouvrir %s\n",fil_mod);
		exit( 1 );
	}
	inivid(argc,argv);
	cru();
	while( lit_modele())
		lit_clavier();
	close( ssin );
	lit_clavier();
	bilan();
}

/*
 * Remplit a_taper avec les NLIG/2 lignes suivantes de ssin en l'affichant au
 * fur et a mesure une ligne sur deux a l'ecran.
 * ramene faux sur la fin de fichier.
 */
lit_modele()
{
	int lig = 1, col = 1;
	register char *pc = a_taper;
	register char c;

	home();	cleos();
	while( ( c = getc( ssin )) != EOF && lig < NLIG){
		if ( iscntrl( c ))	/* balance les controles */
			continue;
		if (c == '\t' )	c = ' ';
		*(pc++) = c;
		if ( c == '\n' ){
			lig += 2;
			col = 1;
			poscur( lig, col );
			continue;
		}
		putchar( c ); fflush(stdout);
		if ( ++col == 80 ){
			lig += 2;
			col = 1;
			poscur( lig, col );
		}
	}
	fa_tap = pc;
	ungetc( c, ssin );
	return( lig >= NLIG ? 1 : 0 );
}

/*
 * saisit sur le clavier en protestant quand c'est different de skya dans
 * a_taper, et en maintenant le curseur au bon endroit.
 */
lit_clavier()
{
	register int mm, sec;
	register struct timeb *reuh = &heure;
	register char * pc, c, c2;
	int lig = 2, col = 1;
	static int i;
	
	pc = a_taper;
	poscur( lig, col );
	while( pc != fa_tap ){
		c2 = *pc;
		ftime( reuh );		/* Quelle heure est-il ? */
		mm = heure.millitm;
		sec = heure.time;
		if ( (c = getchar()) == c2 ){	/* C'est la bonne touche ? */
			pc ++;			/* On passe a la suivante */
			if ( nlus != 0L ){		/* Pas pour la premiere fois */
			    ftime( reuh );	/* Quelle heure est-il ? */
			    if (heure.time > sec)
				heure.millitm += 1000*(heure.time-sec);
						/* Combien de temps ? */
			    alpha[c2].n_fois++;
			    alpha[c2].temps += (heure.millitm - mm)>>6;
			} else ftime( & debut );
			nlus++;
			putchar(c); fflush(stdout);
			if ( ++ col == 80 || c2 == '\n' ){
				lig += 2;
				col = 1;
				poscur( lig, col );
			}
		} else {
		 	alpha[c2].rates++;
			putchar( BEEP ); fflush(stdout);
		}
	}
	ftime( &fin );
}

/*
 * Pour qsort, deux routines qui comparent la vitesse et le nbre d'erreur
 * de frappes sur deux touches.
 */
comparv( t1, t2 )
 struct carac **t1, **t2;
{
	return( (int)((*t1)->temps - (*t2)->temps));
}
compart( t1, t2 )
 struct carac **t1, **t2;
{
	return( (int)((*t2)->rates - (*t1)->rates));
}

/*
 * Exmamine ce qu'a donne le test, et informe de la chose a l'ecran
 */
bilan()
{
	struct carac *frappes[NSYM], *cellela = alpha;
	int k;
	char *pc;
	int i = 0, j = 0;
	int nrates = 0;

	/*
	 * comme on va melanger les structures, met la representation
	 * externe d'une touche dans la structure, l'indice ne suffit plus.
	 */
	for( i = 0 ; i < NSYM; i++)
		alpha[i].car = i;
	/*
	 * Extrait les touches significatives
	 */
	for ( i = 0 ; i < NSYM; i++, cellela++){
		if ( cellela -> n_fois != 0 ){
			frappes[j++] = cellela;
			cellela->temps /= cellela->n_fois;
		}
	}

	qsort( frappes, j, sizeof( pc ), comparv);

	poscur( NLIG, 1);
	cleos();
	printf("\nLes cinq touches ou vous etes le/la plus rapide: ");
	for( i = 0 ; i < 5; i++)
		if ( frappes[i]->car == '\n' )
			printf("\\n ");
		else	printf("%c ", frappes[i]->car);

	printf("\nLes cinq touches ou vous etes le/la plus lent(e): ");
	for( i = j - 1 ; i > j - 6 ; i--)
		if ( frappes[i]->car == '\n' )
			printf("\\n ");
		else	printf("%c ", frappes[i]->car);

	qsort( frappes, j, sizeof( pc ), compart);
	for( k = 0, i = 0; i < j; i++)
		if ( frappes[i]->rates ){
			if (k == 0){
				printf("\nVous avez fait %ld erreurs sur la touche ",
					frappes[i]->rates );
				k = 5;
			} else 	{
				printf( ", %ld sur ",frappes[i]->rates);
				k++;
			}					
			if ( frappes[i]->car == '\n' )
				printf("\\n");
			else	printf("%c", frappes[i]->car);
			if ( k == 9 ){
				printf("\n");
				k = 1;
			}				
			nrates++;
		}
	printf("\nVotre vitesse de frappe est a peu pres de %ld caracteres \
a la minute\n",
		( 60 * nlus)/(fin.time - debut.time));
	printf("avec %d erreurs sur %D caracteres\n", nrates, nlus);
	cuit();
}


# include <sgtty.h>
struct sgttyb ttyb;
int saveflags;
cru()
{
	gtty(2,&ttyb);
	saveflags = ttyb.sg_flags;
	ttyb.sg_flags &= ~ECHO;
	ttyb.sg_flags |= CBREAK;
	stty(2,&ttyb);
}
cuit()
{
	ttyb.sg_flags = saveflags;
	stty(2,&ttyb);
}
onintr()
{
	int i;
	cuit();
	bilan();
	exit(0);
}
