/*
 *	vterms.c	interface pour termcap sur VAX
 *			par Patrick Greussay
 *			Fevrier 1983
 jm, mars 1992 : modifie pour ecrire avec la stdio
 */

#include <stdio.h>
#include <sgtty.h>
	struct sgttyb sg;

	int CO,LI;		/* nbs de cols et de lignes */
static char *CE,*CD,		/* CE=cleol, CD=cleos */
	*CM,			/* CM=cursor-motion */
	*NL,*BC,*ND,*UP,	/* NL=down,BC=left,ND=right,UP=up */
	*HO,			/* HO=home */
	*IS,			/* terminal initialisation string */
	*IF,			/* terminal initialisation file */
	*TI,*TE;		/* debut et fin d'initialisation */
static char PC;			/* caractere de bourrage */

extern short ospeed;

static int tyo(c)char c;{putchar(c);}

inivid(argc,argv)char **argv;{
	static char tcb[512];
	char *tcp,*str;
	char *malloc();
	extern char *tgetstr(),*tgetent();


	gtty(1,&sg);
	ospeed=sg.sg_ospeed;			/* la vitesse */

	if(tgetent(malloc(1024),getenv("TERM")) <= 0)
	{
	  wst("Terminal tres bizarre. Il n'est pas dans termcap!\n"); exit(0);
	}
	tcp=tcb;

	IS=tgetstr("is",&tcp);			/* initialisation */

	str=tgetstr("pc",&tcp);			/* padding character */
	PC = (str != (char *)NULL) ? *str : '\0';

	CO = tgetnum("co");			/* nb colonnes */
	LI = tgetnum("li");			/* nb lignes */
	TI=tgetstr("ti",&tcp);			/* debut */
	TE=tgetstr("te",&tcp);			/* fin */
	HO=tgetstr("ho",&tcp);			/* home */
	UP=tgetstr("up",&tcp);			/* up */
	if(!(NL=tgetstr("nl",&tcp)))NL="\n";	/* down */
	if(!(BC=tgetstr("bc",&tcp)))BC="\b";	/* left */
	ND=tgetstr("nd",&tcp);			/* right */

	CM=tgetstr("cm",&tcp);			/* tgoto capacity */

	CE=tgetstr("ce",&tcp);			/* cleol */
	if((CD=tgetstr("cd",&tcp))==NULL)CD=tgetstr("cl",&tcp);
						/* cleos */
	IF=tgetstr("if",&tcp);
	if(CM == 0)
	{
	  wst("Etonnant, c'est un terminal sans curseur!\n"); exit(1);
	}
	if(IS)tputs(IS,1,tyo);			/* init terminal */
	if(IF)
	{
	  int fd=open(IF,0);int n;char buff[512];
	  if(fd>=0)
	  {
	    while((n=read(fd,buff,511)) > 0){
	      buff[n] = 0;
	      fputs(buff, stdout);
	    }
	    close(fd);
	  }
	}
	if(TI)wst(TI);
}

				/* Pour les Tektro 4025 */
finivid(){
	if(TE)wst(TE);
}

cleol(){tputs(CE,1,tyo);}

cleos(){tputs(CD,1,tyo);}

poscur(x,y)char x,y;{tputs(tgoto(CM,y-1,x-1),1,tyo);}

right(){tputs(ND,1,tyo);}
left(){tputs(BC,1,tyo);}
down(){tputs(NL,1,tyo);}
up(){tputs(UP,1,tyo);}

home(){if(HO)tputs(HO,1,tyo); else poscur(1,1);}

wst(x) char *x;{/* sortir la string d'adresse x */
  fputs(x, stdout);
}


