/* file.c
 Lire et ecrire (des fichiers) pour xtype
	lire, ecrire, relire

 jm, avril 1991
 21 mai 1991 : relire un tampon de taille arbitraire
 27 mai 1991 : retire le fstat ridicule de relire
 14 juin 1991 : remplace O_RDONLY dans l'open par 0, on inclue plus <file.h>
 */
# include <sys/types.h>
# include <sys/stat.h>
# include <stdio.h>

# include "inline.h"

# define BEAUCOUP	1024	/* taille max. du tableau vues relu */

/*
  dans xtype.c
 */
extern int erreurmax, okmax, okmoymax;
extern int perreurmax, pokmax, pokmoymax;
extern int automatique;

/*
 Ici
 */
char * memoire = ".xtype";	/* fichier par defaut */
char * relire();

/* lire  --  lire un fichier dans la memoire */
char *
lire(f)
     char * f;
{
  int fd;
  struct stat etat;
  char * contenu;
  char * remodeler();

  if (automatique == 0)
    if (f == NULL)
# ifndef ENGLISH
      return ("xtype, avril 1991, Copyright (C) Jean Mehat,\
 jm@aristote.univ-paris8.fr,\n\
Universite de Paris 8 Vincennes a Saint Denis\n\
2 rue de la Liberte, 93526 Saint Denis Cedex, France\n\
xtype est distribue SANS GARANTIE D'AUCUNE SORTE.\n\
xtype est un logiciel libre, on peut en distribuer des copies\n\
sous les conditions de la licence publique generale GNU\n\n\n\
xtype est un programme d'apprentissage de la dactylographie,\n\
taper le texte affiche ; a la fin on a des statistiques ;\n\
xtype -help donne la liste des options.\n\
Le bouton de la souris fait sortir un menu pour choisir le type du clavier\n");

# else
      return ("xtype, april 1991, Copyright (C) Jean Mehat,\
 jm@aristote.univ-paris8.fr,\n\
Universite de Paris 8 Vincennes a Saint Denis\n\
2 rue de la Liberte, 93526 Saint Denis Cedex, France\n\
xtype is distributed WITHOUT ANY KIND OF WARRANTY.\n\
xtype is free software, you can distribute copies of it under\n\
the conditions of the GNU general public license\n\n\n\
xtype is a typing tutor : you type the text displayed;\n\
at the end, you have statistics on speed and errors\n\
xtype -help prints a list of options.\n\
Use the mouse button to pop a menu to select the type of the keyboard\n");
# endif
    else if ((fd = open(f, 0)) < 0
	     || fstat(fd, &etat) != 0
	     || (contenu = (char *)xmalloc((unsigned int)
					   (etat.st_size + 1))) == 0
	     || read(fd, contenu, etat.st_size) != etat.st_size
	     || close(fd) < 0)
      return NULL;
    else {
      contenu[etat.st_size] = 0;
      return contenu;
    }
  else
    return remodeler(relire(f), NULL);
}

/* ecrire  --  ecrire le compte-rendu d'une session */
ecrire(cava)
     char * cava;
{
  FILE * fd;

  if ((fd = fopen(memoire, "w")) == NULL)
    perror(memoire);
  else {
    /* trie, c'est mieux */
    int i, j, t;
    for(i = 1; cava[i] != 0; i += 1){
      t = cava[i];
      for(j = i; j > 0 && cava[j - 1] > t; j -= 1)
	cava[j] = cava[j - 1];
      cava[j] = t;
    }
    fprintf(fd, "%d\n%d\n%d\n", erreurmax, okmax, okmoymax);
    fputs(cava, fd);
    fputc(0, fd);
    fclose(fd);
  }
}

/* relire  --  relire le compte rendu d'une session automatique
 */
char * relire(nom)
     char * nom;
{
  FILE * fd;
  static char tampon[BEAUCOUP];
  char * t;
  int i, c;

  if ((fd = fopen(nom == NULL ? memoire : nom, "r")) == NULL)
    t = NULL;
  else if (fscanf(fd, "%d", &perreurmax) != 1
      || fscanf(fd, "%d", &pokmax) != 1
      || fscanf(fd, "%d", &pokmoymax) != 1){
# ifndef ENGLISH
    fprintf(stderr, "le fichier %s est mal forme\n",
# else
    fprintf(stderr, "bad format for file %s\n",
# endif
	    nom == NULL ? memoire : nom);
    t = NULL;
  } else {
    for(i = 0; i < sizeof tampon - 1 && (c = fgetc(fd)) != EOF; i += 1)
      if ((tampon[i] = c) == 0)
	break;
    t = tampon;
    t[i] = 0;
  }
  if (erreurmax == 0 && okmax == 0 && okmoymax == 0){
    erreurmax = perreurmax;
    okmax = pokmax;
    okmoymax = pokmoymax;
  }

  return t;
}
