/*
 Decouper un fichier en mots
 */
# include <stdio.h>
# include <ctype.h>

# define MAXMOT 500		/* longueur max d'un mot */

static char * mot(){
  static char m[MAXMOT];
  int c, i;
  static int point = 0;

  while(!isalpha(c = getchar()))
    if (c == EOF)
      return NULL;
    else if (c == '.')
      point = 1;
    else if (!isspace(c))
      point = 0;

  if (isupper(c)  && point)
    c = tolower(c);

  for(m[0] = c, i = 1; (c = getchar()) != EOF; i += 1)
    if (isalpha(c)
	|| ((m[i - 1] == 'c' || m[i - 1] == 'C') && c == '/')
	|| ((m[i - 1] == 'e' || m[i - 1] == 'E') && c == '\'')
	|| ((m[i - 1] == 'e' || m[i - 1] == 'E'
	     || m[i - 1] == 'a' || m[i - 1] == 'A'
	     || m[i - 1] == 'u' || m[i - 1] == 'U') && c == '`')
	|| ((m[i - 1] == 'a' || m[i - 1] == 'A'
	     || m[i - 1] == 'e' || m[i - 1] == 'E'
	     || m[i - 1] == 'i' || m[i - 1] == 'I'
	     || m[i - 1] == 'o' || m[i - 1] == 'O'
	     || m[i - 1] == 'u' || m[i - 1] == 'U') && c == '^')
	|| ((m[i - 1] == 'a' || m[i - 1] == 'A'
	     || m[i - 1] == 'e' || m[i - 1] == 'E'
	     || m[i - 1] == 'i' || m[i - 1] == 'I'
	     || m[i - 1] == 'o' || m[i - 1] == 'O'
	     || m[i - 1] == 'u' || m[i - 1] == 'U') && c == '"'))
      m[i] = c;
    else {
      m[i] = 0;
      break;
    }
  point = (c == '.');
  return c == EOF ? NULL : m;
}

main(ac, av)
     char * av[];
{
  char * t;
  int i;

  if (ac < 2)
    while((t = mot()) != NULL)
      puts(t);
  else
    for(i = 1; i < ac; i += 1)
      if (freopen(av[i], "r", stdin) == NULL)
	perror(av[i]);
      else
	while((t = mot()) != NULL)
	  puts(t);
}
