/*
  Refaire frap et pfrap avec les milli-secondes du serveur X,
  jm, avril 1991

  jm, 27 mai 1991 : mis en gras les etiquettes des touches connues et les
                    caracteres grises.
  jm, 28 mai 1991 : ajoute le menu pour choisir le type de clavier
  jm, 3 juin 1991 : envoyer les messages et les proprietes a icccm.c
  jm, 16 mars 1993 : l'interruption appelle void interrupt() qui appelle
	cestfini(). Patch pour Linux suggere par Michael Caro <ACPS7221@RyeVm.Ryerson.Ca>
 */

# include <stdio.h>
# include <signal.h>
# include <X11/Xlib.h>
# include <X11/Xutil.h>
char * getenv();

# include "inline.h"
# include "clavier.h"
# include "menu.h"

/*
  parametres qui devraient se modifier sans douleur
 */
int ispace = 2;			/* espace interieur (entre cadre et car) */
int hspace = 2;			/* espace horizontal entre deux touches */
int vspace = 2;			/*   --   vertical entre deux touches */
int tcadre = 1;			/* epaisseur du cadre des touches */

int espace_vert	= 10;		/* entre le clavier et le texte */
int espace_hor =  2;		/* entre le cadre et le texte */

int aiderreur = 1;		/* # d'erreurs avant de flasher un car. >= 0 */

int perreurmax = 4;		/* nombre max. d'erreur */
int pokmax = 4000;		/* temps max. pour trouver la touche (ms) */
int pokmoymax = 4000;		/* temps moyen (en milli-secondes aussi) */

int pour_nouvelle = 2;		/* nombre de sequences sans retirer de touches
				   avant de rajouter une nouvelle touche */
extern int dudebut;		/* si on prend la nouvelle touche en partant
				   du debut ; sinon on tourne dans la liste
				   des touches a apprendre */
/*
 positionnes dans options.c
 */
extern int centremodele;	/* s'il faut centrer le modele */
extern int visible;		/* s'il faut simuler la visible bell */
extern int audible;		/* s'il faut envoyer un beep */
extern int boldness;		/* s'il faut grossir les caracteres grises */
extern int kbtype;		/* le type du clavier  */
extern struct entree keyboard_type[];
/*
  definis et initialises dans commencer.c
 */
extern Display * d;
extern Window w;
extern XRectangle r;		/* la taille de la fenetre */
extern XFontStruct * cfd, * tfd; /* police clavier et police texte */
extern GC gcafaire,		/* texte a faire : noir */
  gcdefait,			/* enlever le texte a faire */
  gcfait,			/* texte fait : gris ou texture */
  gcclav,			/* pour le clavier : noir, ligne de 1 */
  gcclavgras,			/*  idem avec ligne + epaisse */
  gcrev,			/* inverser noir et blanc */
  gcgris2noir,			/* faire passer le gris en noir */
  gcazero;			/* nettoyer une zone */
extern int monochrome;		/* l'ecran n'a-t-il que noir et blanc ? */

/*
 pour evaluer : dans mesurer.c
 */
char * cestfini();
void interrupt();
void cestok(), cestfaux(), cestrien(), cestlache();


char * lire();

char * modele;			/* le texte a taper */

main(ac, av)
     char * av[];
{
 commencer(ac, av);
 initGC();
 clavier(cfd, 1);

 XSelectInput(d, w, (ExposureMask|KeyPressMask|KeyReleaseMask
		     |StructureNotifyMask
# if 0
		     |PropertyChangeMask
# endif /* 0 */
		     |ButtonPressMask|ButtonReleaseMask|OwnerGrabButtonMask));
 protocole();
 XMapWindow(d, w);
 
 if ((modele = lire(av[1])) == 0){
   perror(av[1]);
   exit(1);
 }
 calculer();
 cadrer();
 
 signal(SIGINT, interrupt);
 rouler(menu(keyboard_type, tfd));
}

/* interrupt  --  il arrive une interruption. Afficher les comptes et sortir */
void
interrupt(){
  cestfini(0);
}



Region Rtout, Rclavier, Rtexte;


rouler(menu)
     struct menu * menu;
{
  for(;;){
    XEvent e;

    XNextEvent(d, &e);
    switch(e.type){
    default:
# ifndef ENGLISH
      fprintf(stderr, "(erreur interne) evenement %d (%s) imprevu\n",
	      e.type, nomevent(e.type));
# else
      fprintf(stderr, "(internal error) unmanaged event %d (%s)\n",
	      e.type, nomevent(e.type));
# endif
      break;

    case CirculateNotify:
    case GravityNotify:
    case MapNotify:
    case UnmapNotify:
    case ReparentNotify:
      break;

    case ClientMessage:
      message(&e.xclient);
      break;
# if 0
    case PropertyNotify:
      propriete(&e.xproperty);
      break;
# endif
    case MappingNotify:
      do
	XRefreshKeyboardMapping(&e.xmapping);
      while(XCheckTypedEvent(d, MappingNotify, &e));
      clavier(cfd, 0);
      afficher(Rclavier);
      break;

    case Expose:
      { Region reg = XCreateRegion();
	XRectangle rect;

	do {
	  rect.x = e.xexpose.x;
	  rect.y = e.xexpose.y;
	  rect.width = e.xexpose.width;
	  rect.height = e.xexpose.height;
	  XUnionRectWithRegion(&rect, reg, reg);
	} while(XCheckTypedEvent(d, Expose, &e));
	afficher(reg);
	XDestroyRegion(reg);
      }
      break;

    case ConfigureNotify:
      if (r.width != e.xconfigure.width || r.height != e.xconfigure.height){
	r.width = e.xconfigure.width;
	r.height = e.xconfigure.height;
	calculer();
      }
      break;

    case KeyPress:
    case KeyRelease:
      { char table[12];
	KeySym k;
	int combien;

	combien = XLookupString(&e.xkey, table, sizeof table, &k, NULL);
	table[combien] = 0;
	if (table[0] == '\r')
	  table[0] = '\n';

	if (e.type == KeyPress)
	  pressercar(table[0], e.xkey.time);
	else
	  lachercar(table[0], e.xkey.time);
      }
      break;

    case ButtonPress:
      { int t;
	if ((t = choisir(menu, &e)) != ECHEC){
	  kbtype = t;
	  clavier(cfd, 1);
	  calculer();
	  afficher(Rclavier);
	}
      }
      break;

    case EnterNotify:
    case LeaveNotify:
      ;
    }
  }
}

struct lignaafficher {
  char * t;
  int npix;
  int ncar;
};

struct lignaafficher * lig;
struct lignaafficher * visibles;/* les lignes visibles */
int ilcourant;			/* index de la ligne courante dans lig */
int nvisibles;			/* nombre de lignes visibles */
char * courant;			/* pointe sur le caractere a taper */

XPoint pos_clavier;
XPoint pos_texte;
XPoint pos_curseur;		/* ya d'ailleurs pas de curseur */
# define TFHAUT		(tfd->ascent + tfd->descent)

struct touche * flashe = 0; /* la touche inversee, si elle existe */

/* decouper  --  prendre un texte, termine par '\0', et remplir le tableau
   lig de pointeurs sur les lignes a afficher qui le composent et leur longueur
   en pixels ; on va rappeler ca aussi souvent que la fenetre change de largeur
 */
decouper(texte, largeur, fd)
     char * texte;
     int largeur;
     XFontStruct * fd;
{
  int i, l;
  int nlignes;
# define INITLIGNE 100
# define INCRLIGNE 100

  if (lig != 0){
    free(lig);
  }
  lig = (struct lignaafficher *)xmalloc((nlignes = INITLIGNE) * sizeof lig[0]);

  lig[l = 0].t = &texte[0];
  for(i = 0; texte[i] != 0; i += 1){

    if (i > 0 && texte[i - 1] == '\n'){
      lig[l].ncar = &texte[i] - lig[l].t;
      lig[l].npix = XTextWidth(fd, lig[l].t, lig[l].ncar);
      lig[++l].t = &texte[i];
    } else if (XTextWidth(fd, lig[l].t, &texte[i] - lig[l].t) > largeur){
      int contreoblique = XTextWidth(fd, "\\", 1);
      lig[l].ncar = &texte[i] - lig[l].t - 1;
      while((lig[l - 1].npix = XTextWidth(fd, lig[l].t, lig[l].ncar))
	    > largeur - contreoblique)
	if ((lig[l].ncar -= 1) < 1){
	  fputs(
# ifndef ENGLISH
"la fenetre est trop etroite pour mettre deux car. par ligne, je laisse tomber\n",
# else
"the window is to narrow to draw two characters per line, quitting\n",
# endif
		stderr);
	  exit(1);
	}
      lig[l + 1].t = lig[l].t + lig[l].ncar;
      l += 1;
    }
    if (l == nlignes - 1)
      lig = ((struct lignaafficher *)
	     xrealloc(lig, (nlignes += INCRLIGNE) * sizeof lig[0]));
  }
  if (texte[i - 1] == '\n')
    l += 1;
  lig[l].t = 0;			/* mange la derniere, si pas finie avec '\n' */
  lig[l - 1].npix = XTextWidth(fd, lig[l - 1].t, strlen(lig[l - 1].t));
  lig[l - 1].ncar = strlen(lig[l - 1].t);
}

/* calculer  --  calculer la position du clavier et du texte
		quand la fenetre change de taille ou que le texte ou
		le clavier ont change */
calculer()
{
  pos_clavier.x = (r.width - (trop.x + trop.width)) / 2;
  pos_clavier.y = espace_vert;

  pos_texte.x = espace_hor;
  pos_texte.y = trop.y + 2 * tcadre + vspace + rsize + espace_vert;

  nvisibles = (r.height - pos_texte.y) / TFHAUT;
  if (nvisibles < 0)
    nvisibles = 0;

  decouper(modele, r.width - 2 * espace_hor, tfd);

  if (courant == 0){
    courant = modele;		/* au debut */
    ilcourant = 0;
  } else {
    for(ilcourant = 0; lig[ilcourant].t != 0; ilcourant += 1)
      if (lig[ilcourant + 1].t == 0 || courant < lig[ilcourant + 1].t)
	goto trouve;
# ifndef ENGLISH
    fputs("(internal error) incapable de recalculer la ligne courante, tant pis\n", stderr);
# else
    fputs("(internal error) can't recalculate the current line, quitting\n", stderr);
# endif
    exit(1);
  }
 trouve:
 
  if (Rtout != 0){
    XDestroyRegion(Rtout);
    XDestroyRegion(Rclavier);
    XDestroyRegion(Rtexte);
  }
  { XRectangle rect;

    Rtout = XCreateRegion();
    rect = r;
    r.x = r.y = 0;
    XUnionRectWithRegion(&r, Rtout, Rtout);

    Rclavier = XCreateRegion();
    rect.x =  rect.y = 0;
    rect.width = r.width;
    rect.height = pos_texte.y - tfd->ascent;
    XUnionRectWithRegion(&rect, Rclavier, Rclavier);
    
    Rtexte = XCreateRegion();
    rect.x = 0;
    rect.width = r.width;
    rect.y = pos_texte.y - tfd->ascent;
    rect.height = r.height - rect.y;
    XUnionRectWithRegion(&rect, Rtexte, Rtexte);
  }
}

/* cadrer  --  decider quelles lignes seront visibles */
int
cadrer()
{
  int a_voir = max(0, ilcourant - nvisibles / 3);

  visibles = &lig[a_voir];
  if (centremodele == 0)
    pos_curseur.x = pos_texte.x;
  else
    pos_curseur.x = (r.width - lig[ilcourant].npix) / 2;

  pos_curseur.x += XTextWidth(tfd,lig[ilcourant].t,courant-lig[ilcourant].t);
  pos_curseur.y = pos_texte.y + (ilcourant - a_voir) * TFHAUT;
}

/*
 Dessiner
 */
static int ondessine = 0;

/* afficher  --  tout afficher : le clavier et le texte a taper */
afficher(reg)
     Region reg;
{
  int i;

  ondessine = 1;

  XSetRegion(d, gcclav, reg);
  XSetRegion(d, gcafaire, reg);
  XSetRegion(d, gcfait, reg);
  XSetRegion(d, gcazero, reg);

  XFillRectangle(d, w, gcazero, 0, 0, r.width, r.height);
  /*
    afficher le clavier
   */
  for(i = 0; touche[i].up != 0 || touche[i].down != 0; i += 1)
    dessinetouche(&touche[i]);

  if (flashe != 0)
    invertouche(flashe);

  /*
    afficher le texte
   */
  { register GC gccourant;

    /* en general, on mesure la taille d'une ligne en l'otant du
       pointeur suivant, mais la fin est indiquee avec NULL
     */
    gccourant = gcfait;
    for(i = 0; i < nvisibles && visibles[i].t != 0; i += 1){
      int ouposer = (centremodele == 0
		     ? pos_texte.x : (r.width -  visibles[i].npix) / 2);

      if (courant >= visibles[i].t+visibles[i].ncar|| courant < visibles[i].t){
	XDrawString(d, w, gccourant,
		    ouposer, pos_texte.y + i * TFHAUT + tfd->ascent,
		    visibles[i].t, visibles[i].ncar);
	if (monochrome && gccourant == gcfait){
	  switch(boldness){
	  case 3:
	    XDrawString(d, w, gccourant,
		      ouposer + 1, pos_texte.y + i * TFHAUT + tfd->ascent + 1,
		      visibles[i].t, visibles[i].ncar);
	  case 2:
	    XDrawString(d, w, gccourant,
			ouposer, pos_texte.y + i * TFHAUT + tfd->ascent + 1,
			visibles[i].t, visibles[i].ncar);
	  case 1:
	    XDrawString(d, w, gccourant,
			ouposer + 1, pos_texte.y + i * TFHAUT + tfd->ascent,
			visibles[i].t, visibles[i].ncar);
	  default: ;
	  }
	}
      } else {
	XDrawString(d, w, gccourant,
		    ouposer, pos_texte.y + i * TFHAUT + tfd->ascent,
		    visibles[i].t, courant - visibles[i].t);
	if (monochrome){
	  switch(boldness){
	  case 3:
	    XDrawString(d, w, gccourant,
			ouposer + 1, pos_texte.y + i * TFHAUT + tfd->ascent + 1,
			visibles[i].t, courant - visibles[i].t);
	  case 2: 
	    XDrawString(d, w, gccourant,
			ouposer + 1, pos_texte.y + i * TFHAUT + tfd->ascent,
			visibles[i].t, courant - visibles[i].t);
	  case 1:
	    XDrawString(d, w, gccourant,
			ouposer, pos_texte.y + i * TFHAUT + tfd->ascent + 1,
			visibles[i].t, courant - visibles[i].t);
	  default: ;
	  }
	}
	gccourant = gcafaire;
	XDrawString(d, w, gccourant,
		    ouposer + XTextWidth(tfd, visibles[i].t,
					     courant - visibles[i].t),
		    pos_texte.y + i * TFHAUT + tfd->ascent,
		    courant, visibles[i].ncar - (courant - visibles[i].t));
      }
    }
  }
  XSetRegion(d, gcclav, Rtout);
  XSetRegion(d, gcafaire, Rtout);
  XSetRegion(d, gcfait, Rtout);
  XSetRegion(d, gcazero, Rtout);
}

/* invertouche  --  inverser le contenu de la touche */
invertouche(t)
     struct touche * t;
{
  if (ondessine)
    XCopyArea(d, w, w,
	      ((t->flag & GRISE) ? gcgris2noir : gcrev),
	      pos_clavier.x + t->x, pos_clavier.y + t->y,
	      t->width + 2 * tcadre, t->height + 2 * tcadre,
	      pos_clavier.x + t->x, pos_clavier.y + t->y);
}

/* dessinetouche  --  dessiner une touche */
dessinetouche(t)
     struct touche * t;
{
  register x, y;

  x = pos_clavier.x + t->x;
  y = pos_clavier.y + t->y;

  if ((!monochrome) && t->flag & GRISE) /* nettoyer son rectangle */
    XFillRectangle(d,w, gcfait,
		   x, y,
		   t->width + 2 * tcadre,
		   t->height + 2 * tcadre);
  else
    XFillRectangle(d,w, gcazero,
		   x, y,
		   t->width + 2 * tcadre,
		   t->height + 2 * tcadre);
  
  if (t->flag & SOULIGNER)	/* dessiner son cadre */
    XDrawRectangle(d, w, gcclavgras,
		   x + tcadre, y + tcadre,
		   t->width + tcadre,
		   t->height + tcadre);
  else
    XDrawRectangle(d, w, gcclav,
		   x, y,
		   t->width + 2 * tcadre,
		   t->height + 2 * tcadre);
  
  if (t->up != 0)		/* dessiner son etiquette */
    XDrawString(d, w, gcclav,
		x + ispace + tcadre,
		y + tcadre + cfd->ascent,
		t->up, strlen(t->up));
  if (t->down != 0
      && t->up[0] + ('a' - 'A' ) != t->down[0])
    XDrawString(d, w, gcclav,
		x + ispace + tcadre,
		y + tcadre + 2 * cfd->ascent + cfd->descent, 
		t->down, strlen(t->down));
  if (monochrome && t->flag & GRISE){
    /* 
      sur les ecrans noir&blanc, quand on ecrit le fond de la touche
      sur un fond gris, on ne voit rien : a la place, on fabrique du gras
      (tant bien que mal)
     */
    if (t->up != 0){
      XDrawString(d, w, gcclav,
		  x + ispace + tcadre + 1,
		  y + tcadre + cfd->ascent,
		  t->up, strlen(t->up));
      XDrawString(d, w, gcclav,
		  x + ispace + tcadre,
		  y + tcadre + cfd->ascent + 1,
		  t->up, strlen(t->up));
      XDrawString(d, w, gcclav,
		  x + ispace + tcadre + 1,
		  y + tcadre + cfd->ascent + 1,
		  t->up, strlen(t->up));
    }
    if (t->down != 0 && t->up[0] + ('a' - 'A' ) != t->down[0]){
      XDrawString(d, w, gcclav,
		  x + ispace + tcadre + 1,
		  y + tcadre + 2 * cfd->ascent + cfd->descent, 
		  t->down, strlen(t->down));
      XDrawString(d, w, gcclav,
		  x + ispace + tcadre,
		  y + tcadre + 2 * cfd->ascent + cfd->descent + 1, 
		  t->down, strlen(t->down));
      XDrawString(d, w, gcclav,
		  x + ispace + tcadre + 1,
		  y + tcadre + 2 * cfd->ascent + cfd->descent + 1, 
		  t->down, strlen(t->down));
    }
  }
}

jesais(ascii)
     int ascii;
{
  struct touche * t;

  if ((t = ascii2touche[ascii]) != 0){
    t->flag |= GRISE;
    if (ondessine)
      dessinetouche(t);
  }
}
    
jesaispas(ascii)
     int ascii;
{
  struct touche * t;

  if ((t = ascii2touche[ascii]) != 0){
    t->flag &= ~GRISE;
    if (ondessine)
      dessinetouche(t);
  }
}



pressercar(ascii, heure)
     char ascii;
     unsigned long heure;
{
  static int nerreur;

  flashe != 0 && invertouche(flashe), (flashe = 0);
    
  if (ascii == courant[0]){
    cestok(ascii, heure);	/* c'est le bon caractere */
    nerreur = 0;

    XDrawString(d, w, gcdefait, pos_curseur.x, pos_curseur.y + tfd->ascent,
		courant, 1);
    XDrawString(d, w, gcfait, pos_curseur.x, pos_curseur.y + tfd->ascent,
		courant, 1);
    if (monochrome){
      switch(boldness){
      case 3:
	XDrawString(d, w, gcfait, pos_curseur.x + 1,
		    pos_curseur.y + tfd->ascent + 1,  courant, 1);
      case 2:
	XDrawString(d, w, gcfait, pos_curseur.x,
		    pos_curseur.y + tfd->ascent + 1, courant, 1);
      case 1:
	XDrawString(d, w, gcfait, pos_curseur.x + 1,
		    pos_curseur.y + tfd->ascent, courant, 1);
      }
    }
    courant += 1;
    
    if (courant[0] == 0){	/* fin du texte */
      modele = cestfini(-1);
      courant = 0;
      calculer();
      cadrer();
      afficher(Rtexte);
      return;
    }
    
    if (courant != lig[ilcourant + 1].t){
      pos_curseur.x += XTextWidth(tfd, &ascii, 1);
    } else {
      
      ilcourant += 1;		/* fin de ligne */
      if (lig[ilcourant].t != visibles[nvisibles].t){
      int ouposer = (centremodele == 0
		     ? pos_texte.x : (r.width -  lig[ilcourant].npix) / 2);
	pos_curseur.x = ouposer;
	pos_curseur.y += TFHAUT;
	
      } else {			/* fin de l'ecran */
	cadrer();
	afficher(Rtexte);
      }      
    }
    /*
      ici on peut mettre un prompteur en pos_curseur de la largeur de
      courante[0]
     */

  } else if (ascii != 0 && ascii != courant[0]){
    nerreur += 1;		/* il y a erreur, il faut protester */
    audible && XBell(d, audible);
    cestfaux(ascii, heure);
    { int i;
      for(i = 0; i < visible; i += 1){
	XCopyArea(d, w, w, gcrev, 0, 0, r.width, r.width, 0, 0);
	XCopyArea(d, w, w, gcrev, 0, 0, r.width, r.width, 0, 0);
      }
    }
  } else
    cestrien(ascii, heure);	/* la touche ne fait rien (shift) */

  if (nerreur >= aiderreur && ascii2touche[courant[0]] != 0)
    invertouche(flashe = ascii2touche[courant[0]]);
}

lachercar(ascii, heure)
     long heure;
{
  cestlache(ascii, heure);
}
